config() {
  NEW="$1"
  OLD="$(dirname $NEW)/$(basename $NEW .new)"
  # If there's no config file by that name, mv it over:
  if [ ! -r $OLD ]; then
    mv $NEW $OLD
  elif [ "$(cat $OLD | md5sum)" = "$(cat $NEW | md5sum)" ]; then
    # toss the redundant copy
    rm $NEW
  fi
  # Otherwise, we leave the .new copy for the admin to consider...
}

preserve_perms() {
  NEW="$1"
  OLD="$(dirname $NEW)/$(basename $NEW .new)"
  if [ -e $OLD ]; then
    cp -a $OLD ${NEW}.incoming
    cat $NEW > ${NEW}.incoming
    mv ${NEW}.incoming $NEW
  fi
  config $NEW
}

preserve_perms etc/rc.d/rc.yadifa.new
preserve_perms etc/yadifa/yadifa.conf.new
preserve_perms etc/yadifa/yadifad.conf.new
preserve_perms etc/yadifa/key.conf.new
preserve_perms etc/yadifa/zones.conf.new
preserve_perms etc/logrotate.d/yadifa.new
( cd usr/lib/yadifa ; rm -rf libdnscore.so )
( cd usr/lib/yadifa ; ln -sf libdnscore.so.7.0.4 libdnscore.so )
( cd usr/lib/yadifa ; rm -rf libdnscore.so.7 )
( cd usr/lib/yadifa ; ln -sf libdnscore.so.7.0.4 libdnscore.so.7 )
( cd usr/lib/yadifa ; rm -rf libdnsdb.so )
( cd usr/lib/yadifa ; ln -sf libdnsdb.so.7.0.4 libdnsdb.so )
( cd usr/lib/yadifa ; rm -rf libdnsdb.so.7 )
( cd usr/lib/yadifa ; ln -sf libdnsdb.so.7.0.4 libdnsdb.so.7 )
( cd usr/lib/yadifa ; rm -rf libdnslg.so )
( cd usr/lib/yadifa ; ln -sf libdnslg.so.7.0.4 libdnslg.so )
( cd usr/lib/yadifa ; rm -rf libdnslg.so.7 )
( cd usr/lib/yadifa ; ln -sf libdnslg.so.7.0.4 libdnslg.so.7 )
